#ifndef CEasyGame_h_included
#define CEasyGame_h_included


/***********
simple frame work for game creation
2000/10/4,adas
***********/
#include "SDL.h"
#include "CBmps.h"
#include "CInput.h"
#include "CTime.h"
#include "Cffont.h"
#include "CSprite.h"
#include "CWavs.h"
#include "Cbdffont.h"

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CEASYGAME_MAX_LAYER	4

typedef struct _CEasyGame{
	
	SDL_Surface *screen;
	CTime timer;
	CInput *input;
	Cffont *font;
	CSpriteSet *spriteset[CEASYGAME_MAX_LAYER];
	CWavs *wave;
	
	int (*draw)(struct _CEasyGame*);
	int (*draw_after)(struct _CEasyGame*);
	int (*move[CEASYGAME_MAX_LAYER])(struct _CEasyGame*);
	int (*control)(struct _CEasyGame*);
	void * data;
	int ShutDownTime;
	int system_end;
	int abort;

#define CEASYGAME_LAYERSTATE_PAUSED	(1<<1)
#define CEASYGAME_LAYERSTATE_NODRAW	(2<<1)

	int state[CEASYGAME_MAX_LAYER];
	
}CEasyGame;


CEasyGame * CEasyGameInit(void);
void CEasyGameFree(CEasyGame*);
int CEasyGameStart(CEasyGame*);
void CEasyGameDefaultSetting(CEasyGame *);

void CEasyGameEnd(CEasyGame *,int);
void CEasyGameDetach(CEasyGame *,int layer);
void CEasyGameAll(CEasyGame *);


void CEasyGameDefaultSetting320x240x16(CEasyGame *p);

int CEasyGamePause(CEasyGame *p,int layer);
int CEasyGameUnpause(CEasyGame *p,int layer);
void CEasyGameClearScreen(CEasyGame *p);

#endif
