/****************************
bdf Kanji and ascii file
reading funcs

2000/1/27 by adas
****************************/
#include "CKanji.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "useful.h"
#include <ctype.h>


#define BUF 1000

int CKanjiLoadKanji(CKanji *this,char *filename){
	
	FILE *fp;
	unsigned char buf[BUF],*p,*q;
	int index,i;
	
	fp=fopen(filename,"rb");
	if(fp==NULL){
		fprintf(stderr,"cant open [%s]\n",filename);
		return(-1);
	}
	do{
		if(NULL==fgets(buf,BUF,fp))break;
		if(strstr(buf,"STARTCHAR")==NULL)continue;
		p=strtok(buf," ");
		p=strtok(NULL," ");
		index=(hex2int(*p,*(p+1))-0x20)*96+hex2int(*(p+2),*(p+3))-0x20;
		do{
			fgets(buf,BUF,fp);
			if(strstr(buf,"BITMAP")==NULL)continue;
			i=24;
			p=this->kanji24[index];
			
			do{
				fgets(buf,BUF,fp);
				*p++=hex2int(*buf,*(buf+1));
				*p++=hex2int(*(buf+2),*(buf+3));
				*p++=hex2int(*(buf+4),*(buf+5));
				i--;
			}while(i>0);
			break;
		}while(1);
	}while(1);
	fclose(fp);
	return(0);
}
int CKanjiLoadAscii(CKanji *this,char *filename){
	
	FILE *fp;
	unsigned char buf[BUF],*p,*q;
	int index,i;
	
	fp=fopen(filename,"rb");
	if(fp==NULL){
		fprintf(stderr,"cant open [%s]\n",filename);
		return(-1);
	}
	do{
		if(NULL==fgets(buf,BUF,fp))break;
		if(strstr(buf,"STARTCHAR")==NULL)continue;
		p=strtok(buf," ");
		p=strtok(NULL," ");
		if(isalnum(*(p+1)))continue;
		index=*p;
		do{
			fgets(buf,BUF,fp);
			if(strstr(buf,"BITMAP")==NULL)continue;
			i=24;
			p=this->ascii24[index];
			
			do{
				fgets(buf,BUF,fp);
				*p++=hex2int(*buf,*(buf+1));
				*p++=hex2int(*(buf+2),*(buf+3));
				i--;
			}while(i>0);
			break;
		}while(1);
	}while(1);
	fclose(fp);
	return(0);
}
int CKanjiLoadDefault(CKanji *this){
	
	int result=0;
	result+=CKanjiLoadKanji(this,"jiskan24.bdf");
	result+=CKanjiLoadAscii(this,"12x24.bdf");
	return result;
}

