#ifndef CSprite_h
#define CSprite_h

/*

sprite basis set
2000/10/2,by adas
*/

#define UNDER_PERIOD	12
#define SPRITE_MAX		3072

#include "CBmps.h"
#include "Cffont.h"
#include "SDL.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define SPRITE_ENDSWITCH_OUT	(-3)
#define SPRITE_ENDSWITCH_STOP	(-2)
#define SPRITE_ENDSWITCH_LOOP	(-1)


typedef struct{
	
	int pattern;//if -1,it means loop back to first.if -2,it means annihilation.
	int waitframe;
	
}TSpriteAnimationPattern;

#define ANIME_MAX	32

typedef struct {
	
	Sint32	dx;
	Sint32	dy;
	
	Sint32	destx,desty;
	
	int stopcountdown;//~JEg_E
	int countdown;//ŃJEg_E
	int frame;//\t[
	int anime_index;//if -1,animation is not performed.
	TSpriteAnimationPattern anime[ANIME_MAX+1];
	
	
	
	
}TSpriteSubProperty;


typedef struct{
#define TSPRITEEX_NONE	0
#define TSPRITEEX_SHADOW	1
#define TSPRITEEX_BLINK	2
#define TSPRITEEX_FADEIN	3
#define TSPRITEEX_FADEOUT	4
	int type;//spriteExtentions
	int max_frame;
	int frame;
	
}TSpriteExtention;
typedef struct _TSprite{
	
	Sint32		x;
	Sint32		y;
	int			xystyle;//delta_x̑=10̐=0
	int			number;//graphic number.it ignores when animation is performed.
	int			isExist;
	int			isVisible;
	
	Uint8		alpha;	//alpha value if it is less than 255,it enable alpha blit
	int wait;	//if not zero,disable sprite.
	
	TSpriteExtention	ex;
	
	/*
	int		autodestroy;//FreeSurface at UnsetSprite automatically(string etc.)
	int		datatype;//0...cmps,1...sdlsurface
	*/
	//this is selectable
	CBmps		*graphix;
	Cffont		*font;
	SDL_Surface *surface;
#define TSPRITE_MAX_TEXT	256
	char text[TSPRITE_MAX_TEXT];
#define TSPRITE_GRAPHIC	0
#define TSPRITE_TEXT	1
#define	TSPRITE_SDLSURFACE	2
	int type;
//	SDLSurface	*surface;//for string etc.
	
	int			(*motion)(struct _TSprite*);
	TSpriteSubProperty	prop;
	
}TSprite;

typedef struct{
	
	TSprite*	sprite;
	int			n_sprite;
	
	Sint32 delta_x;
	Sint32 delta_y;
	
	
}CSpriteSet;


CSpriteSet* CSpriteSetInit(int n);
void CSpriteSetFree(CSpriteSet *this);

TSprite* CSpriteSetSetWizNum(CSpriteSet* this,CBmps *graphix,int number);
#define CSpriteSetSet(a,b)	CSpriteSetSetWizNum(a,b,0)

TSprite* CSpriteSetTextSetWizNum(CSpriteSet* this,Cffont *font,int number);
#define CSpriteSetTextSet(a,b)	CSpriteSetTextSetWizNum(a,b,0)

TSprite* CSpriteSetSurfaceSetWizNum(CSpriteSet* this,SDL_Surface *surface,int number);
#define CSpriteSetSurfaceSet(a,b)	CSpriteSetSurfaceSetWizNum(a,b,0)

void CSpriteSetUnset(CSpriteSet* this,TSprite *);
void CSpriteSetDraw(CSpriteSet *this,SDL_Surface *screen);
//int CSpriteSetCollision(CSpriteSet *this,int sp1,int sp2);
void CSpriteSetMove(CSpriteSet *this);


void CSpriteSetClearSprite(CSpriteSet *this);

//for fadein/out change
void CSpriteSetFadeIn(CSpriteSet *this,int frame);
void CSpriteSetFadeOut(CSpriteSet *this,int frame);






/**/

int TSpriteSetAnime(TSprite *sp,int number,int frame,int endswitch);
int TSpriteUnsetAnime(TSprite *sp);

int TSpriteSetPos(TSprite *sp,int x,int y);
//^

#define TSpriteSetMotionLinerRel(sp,dx,dy,frame)	TSpriteSetMotionLiner((sp),(sp)->x>>UNDER_PERIOD,(sp)->y>>UNDER_PERIOD,(dx)+((sp)->x>>UNDER_PERIOD),(dy)+((sp)->y>>UNDER_PERIOD),frame)

int TSpriteSetMotionLiner(TSprite *sp,int sx,int sy,int dx,int dy,int frame);
int TSpriteDetach(TSprite *sp);
//
int TSpriteSetMotionBiliner(TSprite *sp,int sx,int sy,int dx,int dy,int frame);
int TSpriteSetMotionLinerArrange(TSprite *sp,int sx,int sy,int dx,int dy,int frame);
int TSpriteIsMove(TSprite *sp);


//g
int TSpriteSetShadowExtention(TSprite *sp);

int TSpriteSetBlinkExtention(TSprite *sp,int interval);

int TSpriteUnsetExtention(TSprite *sp);

int TSpriteSetFadeOutExtention(TSprite *sp,int interval);
int TSpriteSetFadeInExtention(TSprite *sp,int interval);


#endif
