#include "CTTfont.h"

int CTTfontSystemInit(void){

	/* Initialize the TTF library */
	if ( TTF_Init() < 0 ) {
		fprintf(stderr, "Couldn't initialize TTF: %s\n",SDL_GetError());
		exit(2);
	}

}
int CTTfontSystemFree(void){

	TTF_Quit();
}
CTTfont * CTTfontInit(char *filename,int psize){
	CTTfont *p;
	SDL_Color black={0,0,0,0};
	SDL_Color white={0xff,0xff,0xff,0};
	
	p=(CTTfont *)malloc(sizeof(CTTfont));
	if(!p){
		return NULL;
	}
	memset(p,0,sizeof(CTTfont));
	p->truetype = TTF_OpenFont(filename, psize);
	if ( p->truetype == NULL ) {
		fprintf(stderr, "Couldn't load %d pt font from %s: %s\n",
					psize, filename, SDL_GetError());
		free(p);
		return NULL;
	}
	p->fore=white;
	p->back=black;
	p->height=psize;
	p->skip=psize;
	p->width=psize;
	p->isTransparent=1;
	return p;
	

};
void CTTfontFree(CTTfont *this){
	if(!this)return;
	TTF_CloseFont(this->truetype);
	free(this);
	
};

SDL_Surface *CTTfontRender(CTTfont *this,char *message){
	SDL_Surface *text;
	text = TTF_RenderText(this->truetype, message, this->fore, this->back);
	
	return text;
	
}


