#include "sol2.h"

static int Sol2EnemyFireOutGo(CEasyGame *game,TEnemy *fire){
	TSprite *sp;
#define ENEMY_FIRE_VELOCITY 512
	struct {
		
		int vx,vy;
		int anime1,anime2;
	}set[]={
		{1,0,40,41},
		{-1,0,42,43},
		{0,1,44,45},
		{0,-1,46,47},
		
	};
	
	sp=fire->sp;
	
	sp->prop.dx=(ENEMY_FIRE_VELOCITY*SOL2_VELOCITY_UNIT)*set[fire->direction].vx;
	sp->prop.dy=(ENEMY_FIRE_VELOCITY*SOL2_VELOCITY_UNIT)*set[fire->direction].vy;
	
	TSpriteUnsetAnime(sp);
	TSpriteSetAnime(sp,set[fire->direction].anime1,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[fire->direction].anime2,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[fire->direction].anime1,1,SPRITE_ENDSWITCH_LOOP);
	
	CWavsPlay(game->wave,14);
	
}
static int Sol2EnemyFireOut(CEasyGame *game,TEnemy *enemy){
	TSoldata *data;
	TSprite *sp;
	TEnemy *fire;
	int i;
	
	
	data=game->data;
	i=Sol2GetEnemySlot(game);
	fire=&data->enemy[i];

	fire->type=SOL2_ENEMY_TYPE_FIRE;
	fire->sp=CSpriteSetSetWizNum(data->spriteset,data->enemybmps,SOL2_ENEMY_SPRITE_INDEX);
	fire->direction=enemy->direction;
	sp=fire->sp;
//	sp->number=number;
	sp->x=enemy->sp->x;
	sp->y=enemy->sp->y;
	sp->number=0;
	sp->isVisible=1;
	sp->xystyle=1;
	sp->prop.dx=0;
	sp->prop.dy=0;
	fire->wait=12;
	
	
}


int Sol2EnemySetFireBaneAnime(CEasyGame *game,TEnemy*enemy){
	TSoldata *data;
	TSprite *sp;
	sp=enemy->sp;
	data=game->data;
	
	
	switch(enemy->type){
		case SOL2_ENEMY_TYPE_GARGOIL:
		if(enemy->direction==SOL2_DIR_LEFT){
			TSpriteUnsetAnime(sp);
			TSpriteSetAnime(sp,103,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,105,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,103,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,105,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,103,20,SPRITE_ENDSWITCH_STOP);
		}else{
			
			TSpriteUnsetAnime(sp);
			TSpriteSetAnime(sp,100,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,102,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,100,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,102,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,100,20,SPRITE_ENDSWITCH_STOP);
			
			
		}
		break;
		case SOL2_ENEMY_TYPE_SALAMANDER:
		case SOL2_ENEMY_TYPE_DRAGON:
		
		
		if(enemy->direction==SOL2_DIR_LEFT){
			TSpriteUnsetAnime(sp);
			TSpriteSetAnime(sp,64,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,65,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,64,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,65,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,63,20,SPRITE_ENDSWITCH_STOP);
		}else{
			
			TSpriteUnsetAnime(sp);
			TSpriteSetAnime(sp,61,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,62,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,61,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,62,3,SPRITE_ENDSWITCH_LOOP);
			TSpriteSetAnime(sp,60,20,SPRITE_ENDSWITCH_STOP);
			
			
		}
		break;
		
		
		
		
	}

}

int Sol2EnemySetAnime(CEasyGame *game,TEnemy*enemy){
	
	TSoldata *data;
	TSprite *sp;
	sp=enemy->sp;
	data=game->data;
	switch(enemy->type){
		
		case SOL2_ENEMY_TYPE_PANELMONSTER:
			sp->number=30+enemy->direction;
		break;
		case SOL2_ENEMY_TYPE_SPARK:
			TSpriteUnsetAnime(sp);
			TSpriteSetAnime(sp,10,2,SPRITE_ENDSWITCH_STOP);
			TSpriteSetAnime(sp,11,2,SPRITE_ENDSWITCH_STOP);
			TSpriteSetAnime(sp,10,1,SPRITE_ENDSWITCH_LOOP);
		break;
		case SOL2_ENEMY_TYPE_BURNWEAK:
			TSpriteUnsetAnime(sp);
			TSpriteSetAnime(sp,82,2,SPRITE_ENDSWITCH_STOP);
			TSpriteSetAnime(sp,83,2,SPRITE_ENDSWITCH_STOP);
			TSpriteSetAnime(sp,82,1,SPRITE_ENDSWITCH_LOOP);
		break;
		case SOL2_ENEMY_TYPE_SKULLHEAD:
		
		
		if(enemy->direction==SOL2_DIR_RIGHT){
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,20,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,21,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,22,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,23,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,23,1,SPRITE_ENDSWITCH_LOOP);
		}
		if(enemy->direction==SOL2_DIR_LEFT){
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,23,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,22,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,21,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,20,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,23,1,SPRITE_ENDSWITCH_LOOP);
		}
		break;
		
		case SOL2_ENEMY_TYPE_NUEL:
		
		if(enemy->direction==SOL2_DIR_RIGHT){
			TSpriteUnsetAnime(sp);
			if(enemy->wait==0){
				TSpriteSetAnime(sp,50,8,SPRITE_ENDSWITCH_LOOP);
			}else{
				TSpriteSetAnime(sp,52,8,SPRITE_ENDSWITCH_LOOP);
				
			}
		}
		if(enemy->direction==SOL2_DIR_LEFT){
			TSpriteUnsetAnime(sp);
			if(enemy->wait==0){
			
				TSpriteSetAnime(sp,51,8,SPRITE_ENDSWITCH_LOOP);
			}else{
				TSpriteSetAnime(sp,53,8,SPRITE_ENDSWITCH_LOOP);
			}
		}
		break;
		case SOL2_ENEMY_TYPE_BURN:
			TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,80,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,81,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,80,1,SPRITE_ENDSWITCH_LOOP);
		break;
		case SOL2_ENEMY_TYPE_GARGOIL:
		if(enemy->direction==SOL2_DIR_RIGHT){
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,100,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,101,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,100,1,SPRITE_ENDSWITCH_LOOP);
		}else{
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,103,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,104,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,103,1,SPRITE_ENDSWITCH_LOOP);
		}
		
		break;
		case SOL2_ENEMY_TYPE_SALAMANDER:
		case SOL2_ENEMY_TYPE_DRAGON:
		if(enemy->direction==SOL2_DIR_RIGHT){
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,60,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,61,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,60,1,SPRITE_ENDSWITCH_LOOP);
		}else{
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,63,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,64,8,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,63,1,SPRITE_ENDSWITCH_LOOP);
		}
		break;
		
		case SOL2_ENEMY_TYPE_GOBLIN:{
			int delta=0;
			
		if(enemy->speedup)delta=2;
		if(enemy->direction==SOL2_DIR_RIGHT){
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,70+delta,12,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,71+delta,12,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,70+delta,1,SPRITE_ENDSWITCH_LOOP);
		}else{
		TSpriteUnsetAnime(sp);
		TSpriteSetAnime(sp,74+delta,12,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,75+delta,12,SPRITE_ENDSWITCH_LOOP);
		TSpriteSetAnime(sp,74+delta,1,SPRITE_ENDSWITCH_LOOP);
		}
		}break;
		
	}
}

int Sol2EnemyHanabi(CEasyGame *game,Sint32 x,Sint32 y){
	
	TSoldata *data;
	TSprite *sp;
	TSprite *map;
	int i;
	data=game->data;
	
	sp=CSpriteSetSetWizNum(data->spriteset,data->mapbmps,SOL2_HANABI_SPRITE_INDEX);
	TSpriteSetAnime(sp,102,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,103,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,101,1,SPRITE_ENDSWITCH_LOOP);
	sp->isVisible=1;
	sp->xystyle=1;
	sp->prop.countdown=9;
	sp->x=(x)<<UNDER_PERIOD;
	sp->y=(y)<<UNDER_PERIOD;
	sp->prop.dx=0;
	sp->prop.dy=0;
	
}


int Sol2ClearEnemy(CEasyGame *game){
	TSoldata *data;
	TEnemy *enemy;
	TEnemyGenerator *enemygen;
	data=game->data;
	enemy=&data->enemy[0];
	enemygen=&data->enemygen[0];
	data->n_enemygen=0;
	memset(enemy,0,sizeof(TEnemy)*SOL2_MAX_ENEMY);
	memset(enemygen,0,sizeof(TEnemyGenerator)*SOL2_MAX_ENEMY_GENERATOR);
	
}
int Sol2UnsetEnemy(CEasyGame *game,TEnemy *enemy){
	
	/*
	TSoldata *data;
	TEnemy *enemy;

	data=game->data;
	enemy=&data->enemy[i];
	*/
	TSpriteDetach(enemy->sp);
	memset(enemy,0,sizeof(TEnemy));
	
}



int Sol2GetEnemySlot(CEasyGame *game){
	TSoldata *data;
	TEnemy *enemy;
	int i;
	data=game->data;
	for(i=0;i<SOL2_MAX_ENEMY;++i){
		enemy=&data->enemy[i];
		if(enemy->type==SOL2_ENEMY_TYPE_NOTEXIST)return i;
	}
	return 0;
	
	
}

int Sol2GenerateEnemy(CEasyGame* game){
	
	TSoldata *data;
	TEnemyGenerator *enemygen;
	TEnemy *enemy;
	TSprite *sp;
	int n;
	int i;
	
	
	data=game->data;
	for(i=0;i<data->n_enemygen;++i){
		enemygen=&data->enemygen[i];
		if(enemygen->lefttime<=0){
			int number;
			enemygen->lefttime=enemygen->interval;

			Sol2EnemyHanabi(game,enemygen->x>>UNDER_PERIOD,enemygen->y>>UNDER_PERIOD);

			switch(enemygen->type){
				case SOL2_ENEMY_TYPE_SKULLHEAD:
				case SOL2_ENEMY_TYPE_SALAMANDER:
//				number=30;
				n=Sol2GetEnemySlot(game);
				enemy=&data->enemy[n];
				
				enemy->type=enemygen->type;
				enemy->wait=0;
				
				enemy->velocity=enemygen->velocity;
				enemy->direction=enemygen->direction;
				
//				if(enemgen->vx>0)enemy->direction=0;else enemy->direction=1;
				
				enemy->sp=CSpriteSetSetWizNum(data->spriteset,data->enemybmps,SOL2_ENEMY_SPRITE_INDEX);
				sp=enemy->sp;
//				sp->number=enemygen->number;
				sp->x=enemygen->x;
				sp->y=enemygen->y;
//				sp->prop.dx=0;
				sp->prop.dx=0;
//				sp->prop.dx=enemy->velocity*SOL2_VELOCITY_UNIT;
				sp->prop.dy=1;//tricky?
				
				sp->isVisible=1;
				sp->xystyle=1;
#define ENEMY_COUNTDOWN	500
				
				sp->prop.countdown=ENEMY_COUNTDOWN;
				
			enemy->isFalling=1;
				Sol2EnemySetAnime(game,enemy);
				
				break;
				
			}
			
			
		}
		enemygen->lefttime--;
		
		
	}
	
	
}

int Sol2SetEnemy(
	
	CEasyGame *game,
	enum sol2_enemy_type type,
	int x,
	int y,
	int vx,				//vx is replaced by velocity
	int vy				//vy is replaced by direction.
	
	){
	
	int i;
	TSoldata *data;
	TEnemy *enemy;
	TEnemyGenerator *enemygen;
	TSprite *sp;
	
	struct{
		int vx,vy;
	}set[4]={
		{1,0},
		{-1,0},
		{0,1},
		{0,-1},
	};
	
	
	data=game->data;
	for(i=0;i<SOL2_MAX_ENEMY;++i){
		enemy=&data->enemy[i];
		if(enemy->type==SOL2_ENEMY_TYPE_NOTEXIST){
			
			int number=0;
			
			switch(type){
				
				/*
				case SOL2_ENEMY_TYPE_SPARK:number=10;break;
				case SOL2_ENEMY_TYPE_PANELMONSTER:
				number=30;
				enemy->direction=SOL2_DIR_RIGHT;
				enemy->wait=0;
				
				break;
				
				case SOL2_ENEMY_TYPE_NUEL:number=10;break;
				*/
				case SOL2_ENEMY_TYPE_SKULLHEAD:
				case SOL2_ENEMY_TYPE_SALAMANDER:
				enemygen=&data->enemygen[data->n_enemygen++];
				enemygen->type=type;
				enemygen->x=(x*SOL2_CHIPSIZE)<<UNDER_PERIOD;;
				enemygen->y=(y*SOL2_CHIPSIZE)<<UNDER_PERIOD;;
				enemygen->direction=vy;
				enemygen->velocity=vx;
#define ENEMY_INTERVAL 300
				enemygen->interval=ENEMY_INTERVAL;
				enemygen->lefttime=ENEMY_INTERVAL;
				return;
				break;
				
				
				
				
			}
			enemy->type=type;
			enemy->sp=CSpriteSetSetWizNum(data->spriteset,data->enemybmps,SOL2_ENEMY_SPRITE_INDEX);
			enemy->direction=vy;
			enemy->velocity=vx;
			enemy->firerest=0;
			sp=enemy->sp;
			sp->number=number;
			sp->x=(x*SOL2_CHIPSIZE)<<UNDER_PERIOD;
			sp->y=(y*SOL2_CHIPSIZE)<<UNDER_PERIOD;
			
			sp->prop.dx=(vx*SOL2_VELOCITY_UNIT)*set[vy].vx;
			sp->prop.dy=(vx*SOL2_VELOCITY_UNIT)*set[vy].vy;
			
			if(enemy->type==SOL2_ENEMY_TYPE_BURN){
				sp->prop.dx=0;
				sp->prop.dy=0;
				
			}
			
			
			sp->isVisible=1;
			sp->xystyle=1;
			
			Sol2EnemySetAnime(game,enemy);
			/*
			if(enemy->velocity>=1024)
				TSpriteSetShadowExtention(sp);
			*/
			
			return;
		}
	}
}
extern int Atari(Sint32 x1,Sint32 y1,Sint32 x2,Sint32 y2);
extern int AtariBURN(Sint32 x1,Sint32 y1,Sint32 x2,Sint32 y2);

static int AtariToMe(CEasyGame *game,TEnemy *enemy){
	TSoldata *data;
	TSprite *mysp;
	TMe *me;
	TSprite *sp;
	
	int i;
	data=game->data;
	me=&data->me;
	mysp=me->sp;
	sp=enemy->sp;
	
	
	if(me->dead)return;
	if(me->clear_count)return;
	if(enemy->type==SOL2_ENEMY_TYPE_BURN){
		
	if(AtariBURN(
		sp->x>>UNDER_PERIOD,
		sp->y>>UNDER_PERIOD,
		me->x>>UNDER_PERIOD,
		me->y>>UNDER_PERIOD
	)){
		
		me->dead=1;
		me->dead_count=200;
		
		return 1;
		
	}
		
	}else{
	
	if(Atari(
		sp->x>>UNDER_PERIOD,
		sp->y>>UNDER_PERIOD,
		me->x>>UNDER_PERIOD,
		me->y>>UNDER_PERIOD
	)){
		me->dead=1;
		me->dead_count=200;
		
		
		
		
		
		return 1;
		
	}
	}
	return 0;
	
}
static int AtariToFire(CEasyGame *game,TSprite *sp){
	TSoldata *data;
	TSprite *firesp;
	TFire *fire;
	int i;
	data=game->data;
	fire=&data->fire;
	for(i=0;i<SOL2_MAXFIRE;++i){
		if(!fire->sp[i])continue;
		if(fire->sp[i]->isExist){
			firesp=fire->sp[i];
			
			if(Atari(
				sp->x>>UNDER_PERIOD,
				sp->y>>UNDER_PERIOD,
				firesp->x>>UNDER_PERIOD,
				firesp->y>>UNDER_PERIOD
			)){
				firesp->prop.countdown=1;//tricky?
				return 1;
				
			}
		}
	}
	return 0;
}


#define ENEMY_FIREREST 140
static int Sol2EnemyFireBaneOut(CEasyGame *game,TEnemy *enemy){
	TSoldata *data;
	TSprite *sp;
	TEnemy *fire;
	int i;
	
	struct {
		
		int vx,vy;
		int anime1,anime2;
	}set[]={
		{1,0,110,111},
		{-1,0,112,113},
		
	};
	
//	if(enemy->type!=SOL2_ENEMY_TYPE_SALAMANDER)return;
	
	data=game->data;
	i=Sol2GetEnemySlot(game);
	fire=&data->enemy[i];

	fire->type=SOL2_ENEMY_TYPE_FIREBANE;
	fire->sp=CSpriteSetSetWizNum(data->spriteset,data->enemybmps,SOL2_ENEMY_SPRITE_INDEX);
	sp=fire->sp;
//	sp->number=number;
	sp->x=enemy->sp->x+set[enemy->direction].vx*(SOL2_CHIPSIZE<<UNDER_PERIOD);
	sp->y=enemy->sp->y;
	sp->prop.dx=0;
	sp->prop.dy=0;
#define FIREBANE_COUNTDOWN	20
	sp->prop.countdown=FIREBANE_COUNTDOWN;
	sp->isVisible=1;
	sp->xystyle=1;
	
	TSpriteUnsetAnime(sp);
	TSpriteSetAnime(sp,0,12,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime1,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime2,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime1,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime2,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime1,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime2,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime1,4,SPRITE_ENDSWITCH_STOP);
	TSpriteSetAnime(sp,set[enemy->direction].anime1,1,SPRITE_ENDSWITCH_STOP);
	
	CWavsPlay(game->wave,14);
	
}



#define ME_MAX_VEROCITY 384
#define ME_ACCEL 128

extern Sol2EraseStone(CEasyGame *game,int x,int y);


//fire check
static int Sol2EnemyMoveCheckFire(CEasyGame *game,TEnemy *enemy){
	TSoldata *data;
	TSprite *sp;
	int blockx,blocky,blockdx,blockdy;
	int yes;
	TMap *map;
	
	
	data=game->data;
	sp=enemy->sp;
	map=&data->map;
	
	blockx=((Sint32)(sp->x/*+sp->prop.dx*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)/SOL2_CHIPSIZE;
	blocky=((Sint32)(sp->y/*+sp->prop.dy*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)/SOL2_CHIPSIZE;
	blockdx=((Sint32)(sp->x/*+sp->prop.dx*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)%SOL2_CHIPSIZE;
	blockdy=((Sint32)(sp->y/*+sp->prop.dy*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)%SOL2_CHIPSIZE;
	
	if(enemy->wait>0){
		enemy->wait--;
		if(enemy->wait==0){
			
			Sol2EnemyFireOutGo(game,enemy);
			
		}else return;
	}
	
	if(sp->number==0)return;
	
	if(/*sp->prop.dx<0 && */ blockdx<=SOL2_CHIPSIZE/2){
		if(!IS_MAP_VOID(blockx,blocky)){
			
			if(IS_MAP_SOFTBLOCK(blockx,blocky))Sol2EraseStone(game,blockx,blocky);
			if(enemy->type==SOL2_ENEMY_TYPE_FIRE)Sol2UnsetEnemy(game,enemy);
		}
	}
	if(/*sp->prop.dx>0 &&*/  blockdx>=SOL2_CHIPSIZE/2){
		if(!IS_MAP_VOID(blockx+1,blocky)){
			
			if(IS_MAP_SOFTBLOCK(blockx+1,blocky))Sol2EraseStone(game,blockx+1,blocky);
			if(enemy->type==SOL2_ENEMY_TYPE_FIRE)Sol2UnsetEnemy(game,enemy);
		}
	}
	if(sp->prop.dy<0 && blockdy<=SOL2_CHIPSIZE-SOL2_X_BUFFER*2){
		if(!IS_MAP_VOID(blockx,blocky)){
			
			if(IS_MAP_SOFTBLOCK(blockx,blocky))Sol2EraseStone(game,blockx,blocky);
			if(enemy->type==SOL2_ENEMY_TYPE_FIRE)Sol2UnsetEnemy(game,enemy);
		}
	}
	if(sp->prop.dy>0 &&  blockdy>=SOL2_X_BUFFER*2){
		if(!IS_MAP_VOID(blockx,blocky+1)){
			
			if(IS_MAP_SOFTBLOCK(blockx,blocky+1))Sol2EraseStone(game,blockx,blocky+1);
			if(enemy->type==SOL2_ENEMY_TYPE_FIRE)Sol2UnsetEnemy(game,enemy);
		}
	}
	
}

//nuel and ghost only
#define ENEMY_BIT_STOP 12
static int Sol2EnemyMoveCheckNuel(CEasyGame *game,TEnemy *enemy){
	TSoldata *data;
	TSprite *sp;
	TMe *me;
	
	int blockx,blocky,blockdx,blockdy;
	int yes;
	TMap *map;
	
	
	data=game->data;
	sp=enemy->sp;
	map=&data->map;
	me=&data->me;
	
	blockx=((Sint32)(sp->x/*+sp->prop.dx*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)/SOL2_CHIPSIZE;
	blocky=((Sint32)(sp->y/*+sp->prop.dy*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)/SOL2_CHIPSIZE;
	blockdx=((Sint32)(sp->x/*+sp->prop.dx*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)%SOL2_CHIPSIZE;
	blockdy=((Sint32)(sp->y/*+sp->prop.dy*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)%SOL2_CHIPSIZE;
	
	if(enemy->wait>0){
		enemy->wait--;
		if(enemy->wait<=0){
			
			switch(enemy->direction){
				case SOL2_DIR_RIGHT:
					sp->prop.dx=enemy->velocity*SOL2_VELOCITY_UNIT;
				break;
				case SOL2_DIR_LEFT:
					sp->prop.dx=-enemy->velocity*SOL2_VELOCITY_UNIT;
				break;
				case SOL2_DIR_UP:
					sp->prop.dy=enemy->velocity*SOL2_VELOCITY_UNIT;
				break;
				case SOL2_DIR_DOWN:
					sp->prop.dy=-enemy->velocity*SOL2_VELOCITY_UNIT;
				break;
			
			}
			Sol2EnemySetAnime(game,enemy);
			
		}
		return;
		
	}
	
	
	
	if(sp->prop.dx<0 &&  blockdx<SOL2_CHIPSIZE-SOL2_X_BUFFER){
		if(!IS_MAP_VOID(blockx,blocky)){
			
			if(IS_MAP_SOFTBLOCK(blockx,blocky))Sol2EraseStone(game,blockx,blocky);
			enemy->wait=ENEMY_BIT_STOP;
			enemy->direction=SOL2_DIR_RIGHT;
			Sol2EnemySetAnime(game,enemy);
			sp->prop.dx=0;
		}
	}
	if(sp->prop.dx>0 &&  blockdx>SOL2_X_BUFFER){
		if(!IS_MAP_VOID(blockx+1,blocky)){
			
			if(IS_MAP_SOFTBLOCK(blockx+1,blocky))Sol2EraseStone(game,blockx+1,blocky);
			enemy->wait=ENEMY_BIT_STOP;
			enemy->direction=SOL2_DIR_LEFT;
			Sol2EnemySetAnime(game,enemy);
			sp->prop.dx=0;
		}
	}
	if(sp->prop.dy<0 &&  blockdy<SOL2_CHIPSIZE-SOL2_X_BUFFER){
		if(!IS_MAP_VOID(blockx,blocky)){
			
			if(IS_MAP_SOFTBLOCK(blockx,blocky))Sol2EraseStone(game,blockx,blocky);
			enemy->wait=ENEMY_BIT_STOP;
			enemy->direction=SOL2_DIR_DOWN;
			Sol2EnemySetAnime(game,enemy);
			sp->prop.dy=0;
			
		}
	}
	if(sp->prop.dy>0 &&  blockdy>SOL2_X_BUFFER){
		if(!IS_MAP_VOID(blockx,blocky+1)){
			
			if(IS_MAP_SOFTBLOCK(blockx,blocky+1))Sol2EraseStone(game,blockx,blocky+1);
			enemy->wait=ENEMY_BIT_STOP;
			enemy->direction=SOL2_DIR_UP;
			Sol2EnemySetAnime(game,enemy);
			sp->prop.dy=0;
		}
	}
	
}


#define ENEMY_PRE_FIREBANE 12
//normal enemy argorithm
static int Sol2EnemyMoveCheck(CEasyGame *game,TEnemy *enemy){
	TSoldata *data;
	TSprite *sp;
	int blockx,blocky,blockdx,blockdy;
	int yes;
	TMap *map;
	TMe *me;
	
	
	data=game->data;
	sp=enemy->sp;
	map=&data->map;
	me=&data->me;
	
	blockx=((Sint32)(sp->x/*+sp->prop.dx*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)/SOL2_CHIPSIZE;
	blocky=((Sint32)(sp->y/*+sp->prop.dy*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)/SOL2_CHIPSIZE;
	blockdx=((Sint32)(sp->x/*+sp->prop.dx*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)%SOL2_CHIPSIZE;
	blockdy=((Sint32)(sp->y/*+sp->prop.dy*SOL2_VELOCITY_UNIT*/)>>UNDER_PERIOD)%SOL2_CHIPSIZE;
	
	
	if(enemy->firerest>0)enemy->firerest--;
	//for burn weak
	if(enemy->type==SOL2_ENEMY_TYPE_BURNWEAK && enemy->firerest<=0){
		enemy->type=SOL2_ENEMY_TYPE_BURN;
		Sol2EnemySetAnime(game,enemy);
	}
	if(enemy->wait>0){
		enemy->wait--;
		if(enemy->wait<=0){
			
			switch(enemy->direction){
				case SOL2_DIR_RIGHT:
					sp->prop.dx=enemy->velocity*SOL2_VELOCITY_UNIT;
				break;
				case SOL2_DIR_LEFT:
					sp->prop.dx=-enemy->velocity*SOL2_VELOCITY_UNIT;
				break;
			
			}
			Sol2EnemySetAnime(game,enemy);
			
		}
		return;
		
	}
	
	
	/*fire to me and other features*/
	if(!enemy->isFalling)switch(enemy->type){
		case SOL2_ENEMY_TYPE_GOBLIN:
		case SOL2_ENEMY_TYPE_GARGOIL:
		
		
		if(
			(
			enemy->direction==SOL2_DIR_RIGHT &&
			((me->sp->x-sp->x)>>UNDER_PERIOD)>0 &&
			((me->sp->y-sp->y)>>UNDER_PERIOD)<=SOL2_CHIPSIZE &&
			((me->sp->y-sp->y)>>UNDER_PERIOD)>=-SOL2_CHIPSIZE
			)||
			(
			enemy->direction==SOL2_DIR_LEFT &&
			((sp->x-me->sp->x)>>UNDER_PERIOD)>0 &&
			((sp->y-me->sp->y)>>UNDER_PERIOD)<=SOL2_CHIPSIZE &&
			((sp->y-me->sp->y)>>UNDER_PERIOD)>=-SOL2_CHIPSIZE
			)
		){
			if(enemy->type==SOL2_ENEMY_TYPE_GARGOIL){
			if(enemy->firerest==0){
				sp->prop.dx=0;
				enemy->wait=12+20;
				Sol2EnemySetFireBaneAnime(game,enemy);
				Sol2EnemyFireOut(game,enemy);
				enemy->firerest=ENEMY_FIREREST;
			}
			}else
			if(sp->prop.dx!=0){
				if(!enemy->speedup){
					enemy->speedup=1;
					Sol2EnemySetAnime(game,enemy);
				}
				if(enemy->direction==SOL2_DIR_LEFT)
				sp->prop.dx=-2*enemy->velocity*SOL2_VELOCITY_UNIT;
				else
				sp->prop.dx=2*enemy->velocity*SOL2_VELOCITY_UNIT;
				//return;
			}
			
		}
		
		
		break;
		
		
		case SOL2_ENEMY_TYPE_SALAMANDER:
		case SOL2_ENEMY_TYPE_DRAGON:
		
		if(
			(
			enemy->direction==SOL2_DIR_RIGHT &&
			((me->sp->x-sp->x)>>UNDER_PERIOD)>0 &&
			((me->sp->x-sp->x)>>UNDER_PERIOD)<=SOL2_CHIPSIZE &&
			((me->sp->y-sp->y)>>UNDER_PERIOD)<=SOL2_CHIPSIZE &&
			((me->sp->y-sp->y)>>UNDER_PERIOD)>=-SOL2_CHIPSIZE
			)||
			(
			enemy->direction==SOL2_DIR_LEFT &&
			((sp->x-me->sp->x)>>UNDER_PERIOD)>0 &&
			((sp->x-me->sp->x)>>UNDER_PERIOD)<=SOL2_CHIPSIZE &&
			((sp->y-me->sp->y)>>UNDER_PERIOD)<=SOL2_CHIPSIZE &&
			((sp->y-me->sp->y)>>UNDER_PERIOD)>=-SOL2_CHIPSIZE
			)
		){
			if(sp->prop.dx!=0){
			if(enemy->firerest==0){
				sp->prop.dx=0;
				enemy->wait=12+20;
				Sol2EnemyFireBaneOut(game,enemy);
				Sol2EnemySetFireBaneAnime(game,enemy);
				enemy->firerest=ENEMY_FIREREST;
				return;
			}
			}
			
		}
		break;
		
	}
	switch(enemy->type){
		case SOL2_ENEMY_TYPE_SKULLHEAD:
		case SOL2_ENEMY_TYPE_SALAMANDER:
		case SOL2_ENEMY_TYPE_GOBLIN:
		case SOL2_ENEMY_TYPE_DRAGON:
		case SOL2_ENEMY_TYPE_GARGOIL:
		case SOL2_ENEMY_TYPE_BURN:
		case SOL2_ENEMY_TYPE_BURNWEAK:
		sp->prop.dy+=ME_ACCEL/2*SOL2_VELOCITY_UNIT;
		break;
	}
	if(sp->prop.dy>ME_MAX_VEROCITY*2*SOL2_VELOCITY_UNIT)sp->prop.dy=ME_MAX_VEROCITY*2*SOL2_VELOCITY_UNIT;
	
	if(sp->prop.dx<0 &&  blockdx<=SOL2_CHIPSIZE-SOL2_X_BUFFER){
		int yes=0;
		if(!IS_MAP_VOID(blockx,blocky)){
			sp->x=(blockx*SOL2_CHIPSIZE+SOL2_CHIPSIZE-SOL2_X_BUFFER)<<UNDER_PERIOD;
//			blockdx=SOL2_CHIPSIZE-SOL2_X_BUFFER;
			
			sp->prop.dx=0;
			switch(enemy->type){
				
				
				case SOL2_ENEMY_TYPE_GARGOIL:
				
				enemy->wait=ENEMY_BIT_STOP;
				enemy->direction=SOL2_DIR_RIGHT;
				sp->prop.dx=0;
				
				break;
				case SOL2_ENEMY_TYPE_SKULLHEAD:
				
				enemy->wait=ENEMY_BIT_STOP;
				enemy->direction=SOL2_DIR_RIGHT;
				//sp->prop.dx=enemy->velocity*SOL2_VELOCITY_UNIT;
				if(
				IS_MAP_SOFTBLOCK(blockx,blocky)
				)
				Sol2EraseStone(game,blockx,blocky);
				break;
				
				
				
				case SOL2_ENEMY_TYPE_GOBLIN:
				enemy->speedup=0;
					enemy->wait=ENEMY_BIT_STOP*2;
				if(
				IS_MAP_SOFTBLOCK(blockx,blocky)
				){
					enemy->direction=SOL2_DIR_LEFT;
					TSpriteSetAnime(sp,76,4,SPRITE_ENDSWITCH_LOOP);
					TSpriteSetAnime(sp,77,12,SPRITE_ENDSWITCH_LOOP);
					TSpriteSetAnime(sp,74,12,SPRITE_ENDSWITCH_STOP);
					Sol2EraseStone(game,blockx,blocky);
					
					
					
				}else{
					
					enemy->direction=SOL2_DIR_RIGHT;
					
				}
				break;
				
				
				
				case SOL2_ENEMY_TYPE_SALAMANDER:
				case SOL2_ENEMY_TYPE_DRAGON:

				if(
				IS_MAP_SOFTBLOCK(blockx,blocky)
				){
					enemy->wait=12+20;
					enemy->direction=SOL2_DIR_LEFT;
					Sol2EnemyFireBaneOut(game,enemy);
					Sol2EnemySetFireBaneAnime(game,enemy);
					
					
					
					
				}else{
					
					enemy->wait=ENEMY_BIT_STOP;
					enemy->direction=SOL2_DIR_RIGHT;
					
				}
				
				break;
				
				
			}
			
			
		}
		//`FbN
		switch(enemy->type){
			case SOL2_ENEMY_TYPE_GOBLIN:
			case SOL2_ENEMY_TYPE_DRAGON:
			case SOL2_ENEMY_TYPE_GARGOIL:
			
			if(blockdx<=SOL2_CHIPSIZE-SOL2_X_BUFFER
			&&blockdx>SOL2_CHIPSIZE/2
			&&
			IS_MAP_VOID(blockx,blocky+1)
			){
				enemy->wait=ENEMY_BIT_STOP*2;
				sp->x=((blockx+1)*SOL2_CHIPSIZE-SOL2_X_BUFFER)<<UNDER_PERIOD;
				
				if(enemy->firerest==0){
				enemy->direction=SOL2_DIR_RIGHT;
				enemy->speedup=0;
				}
				sp->prop.dx=0;
			}
			
			
			break;
			
			
		}
		
		
		
	}
	if(sp->prop.dx>0 && blockdx>=SOL2_X_BUFFER){
		if(!IS_MAP_VOID(blockx+1,blocky)){
			sp->x=(blockx*SOL2_CHIPSIZE+SOL2_X_BUFFER)<<UNDER_PERIOD;
			sp->prop.dx=0;
			//sp->prop.dx=-enemy->velocity*SOL2_VELOCITY_UNIT;
			//sp->prop.dx=-enemy->velocity*SOL2_VELOCITY_UNIT;
			
			
			switch(enemy->type){
				case SOL2_ENEMY_TYPE_GARGOIL:
				
				enemy->wait=ENEMY_BIT_STOP;
				enemy->direction=SOL2_DIR_LEFT;
				sp->prop.dx=0;
				
				break;
				case SOL2_ENEMY_TYPE_SKULLHEAD:
			
				enemy->direction=SOL2_DIR_LEFT;
				blockdx=SOL2_X_BUFFER;
				enemy->wait=ENEMY_BIT_STOP;
			
				if(
				IS_MAP_SOFTBLOCK(blockx+1,blocky)
				){
					
				Sol2EraseStone(game,blockx+1,blocky);
				}
				break;
				
				case SOL2_ENEMY_TYPE_GOBLIN:
				enemy->wait=ENEMY_BIT_STOP*2;
				enemy->speedup=0;
				if(
				IS_MAP_SOFTBLOCK(blockx+1,blocky)
				){
					enemy->direction=SOL2_DIR_RIGHT;
					TSpriteSetAnime(sp,72,4,SPRITE_ENDSWITCH_LOOP);
					TSpriteSetAnime(sp,73,12,SPRITE_ENDSWITCH_LOOP);
					TSpriteSetAnime(sp,70,12,SPRITE_ENDSWITCH_STOP);
					Sol2EraseStone(game,blockx+1,blocky);
					
					
					
				}else{
					
					enemy->direction=SOL2_DIR_LEFT;
					
				}
				break;
				
				case SOL2_ENEMY_TYPE_SALAMANDER:
				case SOL2_ENEMY_TYPE_DRAGON:
				if(
				IS_MAP_SOFTBLOCK(blockx+1,blocky)
				){
					enemy->wait=12+20;
					enemy->direction=SOL2_DIR_RIGHT;
					Sol2EnemyFireBaneOut(game,enemy);
					Sol2EnemySetFireBaneAnime(game,enemy);
					
					
					
				}else{
					
					enemy->wait=ENEMY_BIT_STOP;
					enemy->direction=SOL2_DIR_LEFT;
					
				}
				break;
				
				
				
				
			}
			
			
		}
		
		//`FbN
		switch(enemy->type){
			case SOL2_ENEMY_TYPE_GOBLIN:
			case SOL2_ENEMY_TYPE_DRAGON:
			case SOL2_ENEMY_TYPE_GARGOIL:
			
			if(blockdx>=SOL2_X_BUFFER
			&&blockdx<SOL2_CHIPSIZE/2
			&&
			IS_MAP_VOID(blockx+1,blocky+1)
			){
				enemy->wait=ENEMY_BIT_STOP*2;
				sp->x=((blockx)*SOL2_CHIPSIZE+SOL2_X_BUFFER)<<UNDER_PERIOD;
				
				if(enemy->firerest==0){
				enemy->direction=SOL2_DIR_LEFT;
				}
				sp->prop.dx=0;
				enemy->speedup=0;
			}
			
			break;
			
			
		}
	}
	//n
	if(sp->prop.dy>0){
		int yes=0;
		if(!IS_MAP_VOID(blockx,blocky+1)){
			if(blockdx<SOL2_CHIPSIZE-SOL2_X_BUFFER){
				yes=1;
			}
		}
		if(!IS_MAP_VOID(blockx+1,blocky+1)){
			if(blockdx>SOL2_X_BUFFER){
				yes=1;
			}
		}
		if(yes){
			sp->y=(blocky*SOL2_CHIPSIZE)<<UNDER_PERIOD;
			sp->prop.dy=0;
//			if(!sp->prop.dx&&!enemy->wait){
			
			if(enemy->isFalling){
				
				switch(enemy->type){
					case SOL2_ENEMY_TYPE_BURN:
					case SOL2_ENEMY_TYPE_BURNWEAK:
						sp->prop.dx=0;
						return;
					break;
					case SOL2_ENEMY_TYPE_SALAMANDER:
					if(sp->x>me->sp->x)
						enemy->direction=SOL2_DIR_LEFT;
						else
						enemy->direction=SOL2_DIR_RIGHT;
					break;
					case SOL2_ENEMY_TYPE_GOBLIN:
					case SOL2_ENEMY_TYPE_DRAGON:
					case SOL2_ENEMY_TYPE_GARGOIL:
						Sol2EnemyHanabi(game,sp->x>>UNDER_PERIOD,sp->y>>UNDER_PERIOD);
						Sol2UnsetEnemy(game,enemy);
						return;
					break;
				}
				
				
				
				if(enemy->direction==SOL2_DIR_RIGHT)
					sp->prop.dx=enemy->velocity*SOL2_VELOCITY_UNIT;
				else
					sp->prop.dx=-enemy->velocity*SOL2_VELOCITY_UNIT;
				
				Sol2EnemySetAnime(game,enemy);
				
				
			}
			enemy->isFalling=0;
			
			
		}else{
			
			sp->prop.dx=0;
			enemy->wait=0;
			enemy->isFalling=1;
		}
		
	}
	
}



extern	Sol2RoundCheck_Obstacle(CEasyGame *game,TSprite *sp);
extern	Sol2RoundCheck_Normal(CEasyGame *game,TSprite *sp);
extern int Sol2MagicHanabi(CEasyGame *game,Sint32 x,Sint32 y);

int Sol2EnemyMove(CEasyGame *game){
	
	int i;
	TSoldata *data;
	TEnemy *enemy;
	TSprite *sp;
	TMe *me;
	
	data=game->data;
	me=&data->me;
	
	for(i=0;i<SOL2_MAX_ENEMY;++i){
		enemy=&data->enemy[i];
		sp=enemy->sp;
		if(enemy->type==SOL2_ENEMY_TYPE_NOTEXIST)continue;
		if(!sp->isExist){
			Sol2UnsetEnemy(game,enemy);
			continue;
		}
		
		if(AtariToFire(game,sp)&& enemy->type != SOL2_ENEMY_TYPE_BURN
			 &&enemy->type != SOL2_ENEMY_TYPE_BURNWEAK){
			Sol2MagicHanabi(game,sp->x>>UNDER_PERIOD,sp->y>>UNDER_PERIOD);
			Sol2UnsetEnemy(game,enemy);
			CWavsPlay(game->wave,17);
			continue;
		}
		if(sp->number!=0 && !me->dead)AtariToMe(game,enemy);
		
		if(sp->prop.countdown==1 
		&& (
		enemy->type == SOL2_ENEMY_TYPE_SKULLHEAD ||
		enemy->type == SOL2_ENEMY_TYPE_SALAMANDER 
		
		)
		){//gbL[
			
			Sol2EnemyHanabi(game,sp->x>>UNDER_PERIOD,sp->y>>UNDER_PERIOD);
			
			Sol2UnsetEnemy(game,enemy);
			
			CWavsPlay(game->wave,17);
			
		}
		
		
		switch(enemy->type){
			
			case SOL2_ENEMY_TYPE_SPARK:
			
			Sol2RoundCheck_Obstacle(game,sp);
			Sol2RoundCheck_Normal(game,sp);
			
			break;
			case SOL2_ENEMY_TYPE_SKULLHEAD:
			case SOL2_ENEMY_TYPE_SALAMANDER:
			case SOL2_ENEMY_TYPE_GOBLIN:
			case SOL2_ENEMY_TYPE_DRAGON:
			case SOL2_ENEMY_TYPE_GARGOIL:
			case SOL2_ENEMY_TYPE_BURN:
			case SOL2_ENEMY_TYPE_BURNWEAK:
	
			Sol2EnemyMoveCheck(game,enemy);
			
			break;
			
			case SOL2_ENEMY_TYPE_PANELMONSTER:
			
			enemy->wait--;
			if(enemy->wait<=0){
#define PANELMONSTER_WAIT 200
				enemy->wait=PANELMONSTER_WAIT;
//				Sol2EnemyFireBaneOut(game,enemy);
				Sol2EnemyFireOut(game,enemy);
				
			}
			
			break;
			
			case SOL2_ENEMY_TYPE_FIRE:
			case SOL2_ENEMY_TYPE_FIREBANE:
			
			Sol2EnemyMoveCheckFire(game,enemy);
			
			
			break;
			
			
			case SOL2_ENEMY_TYPE_NUEL:
			Sol2EnemyMoveCheckNuel(game,enemy);
			break;
			
			
			
			
			
			
			
		}
	}
}
int EnemyIsExist(CEasyGame *game,int x,int y){
	
	int i;
	TSoldata *data;
	TEnemy *enemy;
	TSprite *sp;
	int ex,ey,edx,edy;
	int extrax,extray;
	
	data=game->data;
	for(i=0;i<SOL2_MAX_ENEMY;++i){
		enemy=&data->enemy[i];
		sp=enemy->sp;
		if(enemy->type==SOL2_ENEMY_TYPE_NOTEXIST)continue;
/*		
		ex=(sp->x>>UNDER_PERIOD)/SOL2_CHIPSIZE;
		ey=(sp->y>>UNDER_PERIOD)/SOL2_CHIPSIZE;
		edx=(sp->x>>UNDER_PERIOD)%SOL2_CHIPSIZE;
		edy=(sp->y>>UNDER_PERIOD)%SOL2_CHIPSIZE;
*/		
		ex=x*SOL2_CHIPSIZE-((sp->x+sp->prop.dx)>>UNDER_PERIOD);
		ey=y*SOL2_CHIPSIZE-((sp->y+sp->prop.dy)>>UNDER_PERIOD);
		
		if(
			ex>-SOL2_CHIPSIZE+SOL2_X_BUFFER &&
			ex<SOL2_CHIPSIZE-SOL2_X_BUFFER &&
			ey>-SOL2_CHIPSIZE+SOL2_X_BUFFER &&
			ey<SOL2_CHIPSIZE-SOL2_X_BUFFER 
		){
			if(enemy->type==SOL2_ENEMY_TYPE_BURN){
				enemy->type=SOL2_ENEMY_TYPE_BURNWEAK;
				Sol2EnemySetAnime(game,enemy);
				enemy->firerest=200;//period for burnweak
			}
			
			
			return 1;
		}
		
	}
	return 0;
	
	
	
	
}
