#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "sol2.h"

typedef struct{
	
	char name[4];
	int score;
	int item;
	int cont;
	
}TSCORE;

#define HIGHSCORE_MEMBER	5
TSCORE HighScore[HIGHSCORE_MEMBER];

static int add_highscore(char *name,int score,int item,int cont){
	int entry,i;
	TSCORE *iscore;
	
	for(entry=0;entry<HIGHSCORE_MEMBER;++entry){
		iscore=&HighScore[entry];
		if(iscore->score<=score)break;
	}

	if(entry==HIGHSCORE_MEMBER)return 1;
	for(i=HIGHSCORE_MEMBER-1;i>entry;--i){
		HighScore[i]=HighScore[i-1];
	}
	strcpy(HighScore[entry].name,name);
	HighScore[entry].score=score;
	HighScore[entry].item=item;
	HighScore[entry].cont=cont;
}
static int load_highscore(const char *filename){
	
	int i;
	FILE *fp;
	
	TSCORE initmember[]={
		{"KOB",100,10,0},
		{"SIG",90,9,0},
		{"KAT",80,8,0},
		{"IMU",70,7,0},
		{"OKR",60,6,0},
		
	};
	
	
	fp=fopen(filename,"rb");
	if(!fp){
		for(i=0;i<HIGHSCORE_MEMBER;++i){
			HighScore[i]=initmember[i];
		}
	}else{
		for(i=0;i<HIGHSCORE_MEMBER;++i){
			fscanf(fp,"%s %d %d %d\n",&HighScore[i].name,&HighScore[i].score
				,&HighScore[i].item,&HighScore[i].cont);
			
		}
		fclose(fp);
	}
	
	return 0;
}
static int save_highscore(const char *filename){
	FILE *fp;
	int i;
	fp=fopen(filename,"wb");
	if(!fp){
		fprintf(stderr,"cant save highscore file!\n");
	}else{
		for(i=0;i<HIGHSCORE_MEMBER;++i){
			fprintf(fp,"%s %d %d %d\n",HighScore[i].name,HighScore[i].score
				,HighScore[i].item,HighScore[i].cont);
			
		}
		fclose(fp);
	}
	
	return 0;
}


static int Sol2ShowHighScoreMove(CEasyGame *game){
	TSoldata *data;
	CInput *inp;
	
	static TSprite *sp;
	
	data=game->data;
	inp=game->input;
	
	CInputUpdate(inp,0);
	if (inp->button[BUTTON_0]) {
		game->system_end=1;
	}

}

static int Sol2ShowHighScoreInit(CEasyGame *game){
	int i;
	char buf[4096];
	TSoldata *data;
	TSCORE *iscore;
	TSprite *sp;
	data=game->data;
	
	sp=CSpriteSetSetWizNum(game->spriteset[COMMON_LAYER],data->mapbmps,1500);
	TSpriteSetPos(sp,0,0);
	sp->number=164;
	sp->isVisible=1;
	TSpriteSetFadeInExtention(sp,120);

	for(i=0;i<HIGHSCORE_MEMBER;++i){
		sp=CSpriteSetTextSetWizNum(
			game->spriteset[COMMON_LAYER],game->font,1500
		);
		sp->isVisible=1;
		TSpriteSetPos(sp,50,i*24+80);
		TSpriteSetFadeInExtention(sp,120);
		iscore=&HighScore[i];
		sprintf(sp->text,"%3s %3d%% %8d%02d",
			iscore->name,iscore->item,iscore->score,iscore->cont);
	}
	
}
int Sol2ShowHighScore(CEasyGame *game){
	TSoldata *data;
	data=game->data;
	
	memset(HighScore,0,sizeof(HighScore));
	
	game->move[COMMON_LAYER]=Sol2ShowHighScoreMove;
	load_highscore("data");
	
	Sol2ShowHighScoreInit(game);
	CEasyGameStart(game);
	CEasyGameDetach(game,COMMON_LAYER);
	return 0;
}

/************
name entry
************/

typedef struct{
	
	TSprite *back;
	TSprite *name;
	TSprite *cursor;
	int x;
	int selectx;//for entrychar
	
}tnameentry;
static tnameentry nameentry;
static int	Sol2NameEntryMove(CEasyGame *game){
	
	TSoldata *data;
	CInput *inp;
	const char entrychar[]="_ABCDEFGHIJKLMNOPQRSTUVWXYZ .abcdefghijklmnopqrstuvwxyz,0123456789";
	const int n_entrychar=sizeof(entrychar)/sizeof(char)-1;
	static TSprite *sp;
	static int wait=0;
	
	data=game->data;
	inp=game->input;
	
	CInputUpdate(inp,0);
	
	if(wait){
		wait--;if(wait)return;
	}
	
	
	if (inp->button[BUTTON_UP] && nameentry.x<3) {
		
		nameentry.selectx--;
		if(nameentry.selectx<0)nameentry.selectx=n_entrychar-1;
		nameentry.name->text[nameentry.x]=entrychar[nameentry.selectx];
		wait=8;
	}
	if (inp->button[BUTTON_DOWN]&& nameentry.x<3) {
		nameentry.selectx++;
		if(nameentry.selectx==n_entrychar)nameentry.selectx=0;
		nameentry.name->text[nameentry.x]=entrychar[nameentry.selectx];
		wait=8;
	}
	if (inp->button[BUTTON_LEFT] &&nameentry.x>0) {
		nameentry.x--;
		wait=12;
		TSpriteSetMotionLiner(
			nameentry.cursor,
			(nameentry.cursor->x>>UNDER_PERIOD),
			(nameentry.cursor->y>>UNDER_PERIOD),
			-4+50+nameentry.x*12,
			-4+80,
			10);
	}
	if (inp->button[BUTTON_RIGHT] && nameentry.x<2) {
		nameentry.x++;
		wait=12;
		TSpriteSetMotionLiner(
			nameentry.cursor,
			(nameentry.cursor->x>>UNDER_PERIOD),
			(nameentry.cursor->y>>UNDER_PERIOD),
			-4+50+nameentry.x*12,
			-4+80,
			10);
	}
	if (inp->button[BUTTON_2]) {
		char buf[4];
		CEasyGameEnd(game,60);
		CSpriteSetFadeOut(game->spriteset[COMMON_LAYER],60);
		
		strncpy(buf,nameentry.name->text,3);
		buf[3]=0;
		
		add_highscore(buf,
		data->me.score,
		(data->MaxItems==0?0:100*data->GotItems/data->MaxItems)
		,data->cont);
		
		
	}
	
}

static int	Sol2NameEntryInit(CEasyGame *game){
	TSprite *sp;
	TSoldata *data;
	data=game->data;
	
	nameentry.name=CSpriteSetTextSetWizNum(
		game->spriteset[COMMON_LAYER],game->font,1500
	);
	sp=nameentry.name;
	sp->isVisible=1;
	TSpriteSetPos(sp,50,80);
	sprintf(sp->text,"___ %3d%% %8d%02d",
		(data->MaxItems==0?0:100*data->GotItems/data->MaxItems)
		,data->me.score,data->cont);
	nameentry.cursor=CSpriteSetSetWizNum(game->spriteset[2],data->mapbmps,1500);
	sp=nameentry.cursor;
	TSpriteSetPos(sp,50-4,80-4);
	sp->number=180;
	sp->isVisible=1;
	
	nameentry.back=CSpriteSetSetWizNum(game->spriteset[2],data->mapbmps,1100);
	sp=nameentry.back;
	TSpriteSetPos(sp,0,0);
	sp->number=165;
	sp->isVisible=1;
	
	CSpriteSetFadeIn(game->spriteset[COMMON_LAYER],60);
	
}
int Sol2NameEntry(CEasyGame *game){
	TSoldata *data;
	data=game->data;
	
	memset(HighScore,0,sizeof(HighScore));
	memset(&nameentry,0,sizeof(nameentry));
	
	load_highscore("data");
	if(data->me.score<HighScore[4].score)return;
	
	game->move[COMMON_LAYER]=Sol2NameEntryMove;
	Sol2NameEntryInit(game);

	CWavsPlayMusicStyle(game->wave,52);

	CEasyGameStart(game);
	save_highscore("data");
	CEasyGameDetach(game,COMMON_LAYER);
	Sol2ShowHighScore(game);
	return 0;
}


