#include "sol2.h"
int Sol2UnsetItem(CEasyGame *game,TItem *item){
	
	
	if(item->sp)TSpriteDetach(item->sp);
	memset(item,0,sizeof(TItem));
	
}

int Sol2ItemClear(CEasyGame *game){
	TSoldata *data;
	TItem *item;
	int i;
	data=game->data;
	for(i=0;i<SOL2_MAX_ITEM;++i){
		item=&data->item[i];
		Sol2UnsetItem(game,item);
	}
	
}


TItem* Sol2FindItemSlotByXY(CEasyGame *game,int x,int y){
	TSoldata *data;
	TItem *item;
	int i;
	data=game->data;
	
	for(i=0;i<SOL2_MAX_ITEM;++i){
		item=&data->item[i];
		if(item->type==SOL2_ITEM_TYPE_NOTEXIST)continue;
		if(item->x==x && item->y==y)return item;
	}
	return NULL;
	
}
TItem* Sol2GetItemSlot(CEasyGame *game){
	TSoldata *data;
	TItem *item;
	int i;
	data=game->data;
	for(i=0;i<SOL2_MAX_ITEM;++i){
		item=&data->item[i];
		if(item->type==SOL2_ITEM_TYPE_NOTEXIST)return item;
	}
	return NULL;
	
	
}


//ACẽXvCgēx`
int Sol2ItemReset(CEasyGame *game){
	TSoldata *data;
	int i;
	TItem *item;
	TSprite *sp;
	static table[]={
		0,
		40,41,42,43,44,45,46,47,48,49,
		50,51,52,53,54,55,56,57,
	};
	TMap *map;
	
	data=game->data;
	map=&data->map;
	
	for(i=0;i<SOL2_MAX_ITEM;++i){
		item=&data->item[i];
		if(item->type==SOL2_ITEM_TYPE_NOTEXIST)continue;
		item->sp=CSpriteSetSetWizNum(data->spriteset,data->mapbmps,SOL2_ITEM_SPRITE_INDEX);
		sp=item->sp;
		sp->number=table[item->type];
		TSpriteSetPos(sp,item->x*SOL2_CHIPSIZE,item->y*SOL2_CHIPSIZE);
		sp->xystyle=1;
		if(!item->hidden&&!IS_MAP_SOFTBLOCK(item->x,item->y)){
			sp->isVisible=1;
		}else{
			item->hidden=1;
			sp->isVisible=0;
		}
	}
}


TItem* Sol2SetItem(
	CEasyGame *game,
	enum sol2_item_type type,
	int x,
	int y,
	int hidden
	
	){
	
	static table[]={
		0,
		40,41,42,43,44,45,46,47,48,49,
		50,51,52,53,54,55,56,57,
	};
	
	int i;
	TSoldata *data;
	TItem *item;
	TSprite *sp;
	data=game->data;
	
	item=Sol2GetItemSlot(game);
	if(!item){
		return NULL;
	}
	item->type=type;
	item->x=x;
	item->y=y;
	item->hidden=hidden;
	item->sp=CSpriteSetSetWizNum(data->spriteset,data->mapbmps,SOL2_ITEM_SPRITE_INDEX);
	if(
	item->type==SOL2_ITEM_TYPE_TRANSJUELBLUE||
	item->type==SOL2_ITEM_TYPE_TRANSJUELRED)item->canTransform=1;
	sp=item->sp;
	sp->number=table[item->type];
	TSpriteSetPos(sp,item->x*SOL2_CHIPSIZE,item->y*SOL2_CHIPSIZE);
	sp->isVisible=1;
	sp->xystyle=1;
	
	return item;
}

extern int Atari(Sint32 x1,Sint32 y1,Sint32 x2,Sint32 y2);
int Sol2ItemAtariToMe(CEasyGame *game,TItem *item){
	
	int i;
	TSoldata *data;
	TSprite *sp;
	TMe *me;
	
	int scoretable[]={
		0,
		5,10,20,40,100,200,500,1000,5,10,
		0,0,0,0,0,0,0,0,
	};
	
	data=game->data;
	sp=item->sp;
	me=&data->me;
	if(me->dead)return;
	if(me->clear_count)return;
	if(item->hidden)return;
	if(Atari(
		sp->x>>UNDER_PERIOD,
		sp->y>>UNDER_PERIOD,
		me->x>>UNDER_PERIOD,
		me->y>>UNDER_PERIOD
	)){
		CWavsPlay(game->wave,13);
		switch(item->type){
			case SOL2_ITEM_TYPE_SANDCLOCKBLUE: me->restriction_time*=2;break;
			case SOL2_ITEM_TYPE_SANDCLOCKRED: me->restriction_time=5000;break;
			case SOL2_ITEM_TYPE_FIREPOT: me->left_fire++;break;
			case SOL2_ITEM_TYPE_EXTENDPOT: me->left++;break;
			case SOL2_ITEM_TYPE_CRYSTALBLUE: me->fire_length++;break;
			case SOL2_ITEM_TYPE_CRYSTALRED: me->fire_length+=2;break;
			case SOL2_ITEM_TYPE_BELL: me->left_fire+=5;break;
			case SOL2_ITEM_TYPE_SCROLL: me->left_fire+=5;break;

		}
		me->score+=scoretable[item->type];
		Sol2UnsetItem(game,item);
		data->GotItems++;
		
		
		
		return 1;
		
	}
}


//JZL̏pŃACeo
int Sol2RevealItem(CEasyGame *game,int x,int y){
	int i;
	TSoldata *data;
	TSprite *sp;
	TMe *me;
	TItem *item;
	
	item=Sol2FindItemSlotByXY(game,x,y);
	if(!item)return;
	if(item->hidden){
		item->hidden=0;
		item->sp->isVisible=1;
	}
	
}

int Sol2ItemMove(CEasyGame *game){
	int i;
	TSoldata *data;
	TSprite *sp;
	TMe *me;
	TItem *item;
	data=game->data;
	for(i=0;i<SOL2_MAX_ITEM;++i){
		item=&data->item[i];
		if(item->type==SOL2_ITEM_TYPE_NOTEXIST)continue;
		Sol2ItemAtariToMe(game,item);
	}
	return;
	
}


