#include "sol2.h"



//Initializer
static char *enemybgfile="enemybg.txt";
static char *mapbgfile="mapbg.txt";
static char *chrbgfile="charabg.txt";
#ifdef Macintosh
static char *enemybgdir=".:enemies:";
static char *mapbgdir=".:system/bmp:";
static char *chrbgdir=".:character:";
static char *wavdir=".:system:wav:";
#else
static char *enemybgdir="./enemies/";
static char *mapbgdir="./system/bmp/";
static char *chrbgdir="./character/";
static char *wavdir="./system/wav/";
#endif

static char *configfile="sol.cnf";

int Sol2Init(CEasyGame *game){
	TSoldata *data;
	TMe *me;
	TMe *fire;
	data=game->data;
	
	data->mapbmps=CBmpsInit(256);
	CBmpsLoadFromFileDir(data->mapbmps,mapbgdir);
//	CBmpsLoadFromFileWithDir(data->mapbmps,mapbgfile,mapbgdir);
	data->charabmps=CBmpsInit(256);
	CBmpsLoadFromFileDir(data->charabmps,chrbgdir);
//	CBmpsLoadFromFileWithDir(data->charabmps,chrbgfile,chrbgdir);
	data->enemybmps=CBmpsInit(256);
	CBmpsLoadFromFileDir(data->enemybmps,enemybgdir);
//	CBmpsLoadFromFileWithDir(data->enemybmps,enemybgfile,enemybgdir);
	game->wave=CWavsInit(256);
	CWavsLoadFromFileDir(game->wave,wavdir);
	
	data->configuration=CMapInit(256);
	CMapLoadFromFile(data->configuration,configfile);
	
/*
	for(i=0;i<SOL2_MAXFIRE;++i)
		fire->sp[i]=CSpriteSetSetWizNum(game->spriteset,data->charabmps,SOL2_FIRE_SPRITE_INDEX);
*/
}
int Sol2Free(CEasyGame *game){
	TSoldata *data;
	data=game->data;
	
	CBmpsFree(data->mapbmps);
	CBmpsFree(data->charabmps);
	CBmpsFree(data->enemybmps);
	CWavsFree(game->wave);
	CMapSaveToFile(data->configuration,configfile);
	CMapFree(data->configuration);
}

int Sol2(CEasyGame *game){
	
	static TSoldata data;
	memset(&data,0,sizeof(TSoldata));
	
	game->data=&data;
	
	Sol2Init(game);
	
//	CEasyGameStart(game);
	SDL_Delay(1000);
	Sol2Main(game);
	
	Sol2Free(game);
	CEasyGameDetachAll(game);
	
}


