#ifndef _sol2_h_included
#define _sol2_h_included

/*

solomon's key another data


*/

#include "CEasyGame.h"
#include "CMap.h"

//#define SOL2_VELOCITY_UNIT	((Sint32)(0.2*(1<<UNDER_PERIOD)))
//2561hbg
#define SOL2_VELOCITY_UNIT	16


//5dot̗V(x)
#define	SOL2_X_BUFFER	5


#define SOL2_HANABI_SPRITE_INDEX	1200

#define SOL2_ME_SPRITE_INDEX	600
enum sol2_me_state{
	SOL2_ME_STATE_NONE,
	SOL2_ME_STATE_STAND,
	SOL2_ME_STATE_WALK,
	SOL2_ME_STATE_WALKFAST,
	SOL2_ME_STATE_JUMPREADY,
	SOL2_ME_STATE_STANDREADY,
	SOL2_ME_STATE_JUMP,
	SOL2_ME_STATE_CROUCH,
	SOL2_ME_STATE_MAGIC,
	
};
typedef struct{
	
	TSprite *sp;
	Sint32	x,y;
	Sint32	vx,vy;
	Sint32	ax,ay;
	
	enum sol2_me_state	state;
	
	int isJumpEnabled;
#define SOL2_DIR_RIGHT	0
#define SOL2_DIR_LEFT	1
#define SOL2_DIR_UP	2
#define SOL2_DIR_DOWN	3

	int direction;
	
	int restriction_time;
	int left;
	
	int left_fire;
	int fire_length;
	
	int wait;//for various wait
	int isCrouch;
	int isFlying;
	
	
	int dead;
	int dead_count;
	int clear_count;
	
	int score;
	
}TMe;




enum sol2_enemy_type{
	
	SOL2_ENEMY_TYPE_NOTEXIST=0,
	SOL2_ENEMY_TYPE_SPARK,
	SOL2_ENEMY_TYPE_SKULLHEAD,
	SOL2_ENEMY_TYPE_PANELMONSTER,
	SOL2_ENEMY_TYPE_FIRE,
	
	SOL2_ENEMY_TYPE_NUEL,
	SOL2_ENEMY_TYPE_SALAMANDER,
	SOL2_ENEMY_TYPE_GOBLIN,
	SOL2_ENEMY_TYPE_BURN,
	SOL2_ENEMY_TYPE_DRAGON,
	
	SOL2_ENEMY_TYPE_GARGOIL,
	SOL2_ENEMY_TYPE_FIREBANE,
	SOL2_ENEMY_TYPE_BURNWEAK,
	

};

typedef struct{
	
	TSprite *sp;
	enum sol2_enemy_type type;
	int direction;
	int velocity;
	int wait;
	int firerest;//for gargoil
	int isFalling;
	int speedup;//for goblins

}TEnemy;

#define SOL2_ENEMY_SPRITE_INDEX	800
typedef struct{
	
	enum sol2_enemy_type type;
	int interval;
	int lefttime;
	int vx;
	int vy;
	int x;
	int y;
	int velocity;
	int direction;
	
}TEnemyGenerator;


enum sol2_item_type{
	
	SOL2_ITEM_TYPE_NOTEXIST=0,

	SOL2_ITEM_TYPE_JUELBLUE,
	SOL2_ITEM_TYPE_JUELRED,
	SOL2_ITEM_TYPE_COINSILVER1,
	SOL2_ITEM_TYPE_COINSILVER2,
	SOL2_ITEM_TYPE_COINGOLD1,

	SOL2_ITEM_TYPE_COINGOLD2,
	SOL2_ITEM_TYPE_BIGOIN1,
	SOL2_ITEM_TYPE_BIGOIN2,
	SOL2_ITEM_TYPE_TRANSJUELBLUE,
	SOL2_ITEM_TYPE_TRANSJUELRED,
	
	SOL2_ITEM_TYPE_SANDCLOCKBLUE,
	SOL2_ITEM_TYPE_SANDCLOCKRED,
	SOL2_ITEM_TYPE_FIREPOT,
	SOL2_ITEM_TYPE_EXTENDPOT,
	SOL2_ITEM_TYPE_CRYSTALBLUE,

	SOL2_ITEM_TYPE_CRYSTALRED,
	SOL2_ITEM_TYPE_BELL,
	SOL2_ITEM_TYPE_SCROLL,

};
#define SOL2_ITEM_SPRITE_INDEX	500
typedef struct{
	
	TSprite *sp;
	enum sol2_item_type type;
	int x;
	int y;
	int hidden;
	int canTransform;
}TItem;






#define SOL2_CHIPSIZE	24

#define SOL2_MAP_X	20
#define SOL2_MAP_Y	15
#define SOL2_MAP_SPRITE_INDEX	100
typedef struct{
	
	TSprite *sp[SOL2_MAP_X][SOL2_MAP_Y];
	
	Sint32 delta_x;
	Sint32 delta_y;
	
	
	
}TMap;

#define SOL2_FIRE_SPRITE_INDEX	1100
#define SOL2_MAXFIRE	16
typedef struct{
	TSprite *sp[SOL2_MAXFIRE];
	
	
	
}TFire;

typedef struct{
	
	CBmps *mapbmps;
	TMap map;
	
	CBmps *charabmps;
	TMe me;
	TFire fire;
	
	CWavs *wavs;
	
	CSpriteSet *spriteset;
	
#define SOL2_MAX_ENEMY 256
	CBmps *enemybmps;
	TEnemy enemy[SOL2_MAX_ENEMY];
	
#define SOL2_MAX_ENEMY_GENERATOR 64
	int n_enemygen;
	TEnemyGenerator enemygen[SOL2_MAX_ENEMY_GENERATOR];
	
	TItem key;
	TItem door;
#define SOL2_MAX_ITEM	(SOL2_MAP_X*SOL2_MAP_Y)
	TItem item[SOL2_MAX_ITEM];
	
	int abort;
	char mapfilename[1024];
	char mapfiledir[1024];
	
	
#define SOL2_MAX_STAGE	8
	int stage;
	int cleared;
	
	int isPaused;
	
	int menu_selected;
	
	TSprite *uppertext;
	TSprite *lowertext;
	
	
	
	//for sarvage game
	int ItemLoaded;
	int MaxItems;
	int GotItems;
	int cont;//continue times
	
	CMap *configuration;
	
	
}
TSoldata;




#define IS_MAP_VOID(x,y) (map->sp[(x)][(y)]->number!=10 && map->sp[(x)][(y)]->number!=11 && map->sp[(x)][(y)]->number!=12)
#define IS_MAP_CANNOT_MAGIC(x,y) (map->sp[(x)][(y)]->number==10 || map->sp[(x)][(y)]->number==14)
#define IS_MAP_SOFTBLOCK(x,y) (map->sp[(x)][(y)]->number==11 || map->sp[(x)][(y)]->number==12)

#define GAME_LAYER	1
#define COMMON_LAYER	2









int Sol2Main(CEasyGame *);
int Sol2(CEasyGame *);
#endif

