#include "Sol2.h"

#include "item.h"
/* key reading*/
static int keyread(CEasyGame *p){
	
	SDL_Event ev;
	static int screennumber=0;
	SDLKey *key;
	char buf[1000];
	
	while(SDL_PollEvent(&ev)){
		switch(ev.type){
			case SDL_QUIT:
			{
				return 1;
			}
			break;
			case SDL_KEYDOWN: {
				key=&(ev.key.keysym.sym);
				if(*key==293){//F12
					
					sprintf(buf,"screenshot%04d.bmp",screennumber++);
					if(screennumber>9999)screennumber=0;
					SDL_SaveBMP(p->screen,buf);
					
				}
				if(*key==27){//ESC
					return 1;
				}
			}break;
		}
	}
	
	
	return 0;
	
}


static int Sol2MapMove(CEasyGame *game){
	TSoldata *data;
	int i,j;
	CSpriteSet *spset;
	TSprite *sp;
	TMap *map;
	TMe *me;
	Sint32 delta_x,delta_y;
	
	data=game->data;
	map=&data->map;
	me=&data->me;
	spset=game->spriteset[GAME_LAYER];
	
	delta_x=(me->sp->x>>UNDER_PERIOD)-(game->screen->w-SOL2_CHIPSIZE)/2;
	delta_y=(me->sp->y>>UNDER_PERIOD)-(game->screen->h-SOL2_CHIPSIZE)/2;
	
	if(delta_x<0)delta_x=0;
	if(delta_y<0)delta_y=0;
	if(delta_x+game->screen->w>SOL2_CHIPSIZE*SOL2_MAP_X)
		delta_x=SOL2_MAP_X*SOL2_CHIPSIZE-game->screen->w;
	if(delta_y+game->screen->h>SOL2_CHIPSIZE*SOL2_MAP_Y)
		delta_y=SOL2_MAP_Y*SOL2_CHIPSIZE-game->screen->h;
	
	
	/*
	for(j=0;j<SOL2_MAP_Y;++j)
	for(i=0;i<SOL2_MAP_X;++i){
		sp=map->sp[i][j];
		sp->delta_x=delta_x<<UNDER_PERIOD);
		sp->delta_y=delta_y<<UNDER_PERIOD);
		
	}
	*/
	
	
	
	spset->delta_x=delta_x<<UNDER_PERIOD;
	spset->delta_y=delta_y<<UNDER_PERIOD;
	
	
	
	/*
	map->delta_x=delta_x;
	map->delta_y=delta_y;
	*/

//adjust
/*
	me->sp->x=((me->x>>UNDER_PERIOD)-delta_x)<<UNDER_PERIOD;
	me->sp->y=((me->y>>UNDER_PERIOD)-delta_y)<<UNDER_PERIOD;
*/
}

int Sol2AttachMapChipSprite(CEasyGame *game){
	
	TSoldata *data;
	int i,j;
	TSprite *sp;
	TMe *me;
	
	data=game->data;
	
	for(j=0;j<SOL2_MAP_Y;++j)
	for(i=0;i<SOL2_MAP_X;++i){
		data->map.sp[i][j]=CSpriteSetSetWizNum(game->spriteset[GAME_LAYER],data->mapbmps,SOL2_MAP_SPRITE_INDEX);
		
	}
	
	
	
	me=&data->me;
	me->sp=CSpriteSetSetWizNum(game->spriteset[GAME_LAYER],data->mapbmps,SOL2_ME_SPRITE_INDEX);
	me->sp->x=48<<UNDER_PERIOD;
	me->sp->y=48<<UNDER_PERIOD;
	data->me.sp->xystyle=1;
	me->sp->isVisible=1;
	

}
static int Sol2LoadMap(CEasyGame *game){
	
	TSoldata *data;
	int i,j;
	TSprite *sp;
	TMe *me;
	TMap *map;
	TItem *item;
	int x,y;
	int mex=1,mey=1;
	int doorx=1,doory=1;
	int keyx=1,keyy=1;
	int number;
	FILE *fp;
	
	int itemx,itemy,itemtype,itemhidden;
	
	Sol2AttachMapChipSprite(game);
	data=game->data;
	
	
	for(j=0;j<SOL2_MAP_Y;++j)
	for(i=0;i<SOL2_MAP_X;++i){
		sp=data->map.sp[i][j];
		
		sp->number=0;
		if(j==0||j==SOL2_MAP_Y-1||i==0||i==SOL2_MAP_X-1)sp->number=10;
		sp->isVisible=1;
		sp->x=((i*SOL2_CHIPSIZE)<<UNDER_PERIOD);
		sp->y=((j*SOL2_CHIPSIZE)<<UNDER_PERIOD);
		sp->xystyle=1;
	}
	
	fp=fopen(data->mapfilename,"rb");
	if(fp){
		
		for(j=0;j<SOL2_MAP_Y;++j)
		for(i=0;i<SOL2_MAP_X;++i){
			sp=data->map.sp[i][j];
			
			fscanf(fp,"%d ",&number);
			sp->number=number;
		}
		
		fscanf(fp,"\n%d %d %d %d %d %d\n",&mex,&mey,&doorx,&doory,&keyx,&keyy);
		data->map.sp[keyx][keyy]->number=22;
		data->map.sp[doorx][doory]->number=20;
		
		do{
			fscanf(fp,"%d %d %d %d\n",&itemtype,&itemx,&itemy,&itemhidden);
			if(itemtype==-1)break;
			item=Sol2SetItem(game,itemtype,itemx,itemy,itemhidden);
			if(itemhidden&&item){
				TSpriteSetBlinkExtention(item->sp,10);
			}
		}while(1);
		
		fclose(fp);
	}else{
		fprintf(stderr,"cannot open %s\n",data->mapfilename);
	}
	
	
}
static int Sol2SaveMap(CEasyGame *game){

	TSoldata *data;
	int i,j;
	TSprite *sp;
	TMe *me;
	TItem *item;
	FILE *fp;
	TMap *map;
	
	int x,y;
	int mex=1,mey=1;
	int doorx=1,doory=1;
	int keyx=1,keyy=1;
	int number;
	
	data=game->data;
	map=&data->map;
	
	
	fp=fopen(data->mapfilename,"wb");
	if(!fp){
		fprintf(stderr,"cannot save file\n");
		return;
	}
	
	for(y=0;y<SOL2_MAP_Y;++y){
	for(x=0;x<SOL2_MAP_X;++x){
		
		number=map->sp[x][y]->number;
		if(number==22){
			keyx=x;
			keyy=y;
			number=0;
		}
		if(number==20){
			doorx=x;
			doory=y;
			number=0;
		}
		
		fprintf(fp,"%d ",number);
		
	}
	}
	//me,key,door
	fprintf(fp,"\n%d %d %d %d %d %d\n",mex,mey,doorx,doory,keyx,keyy);

	//items
	for(i=0;i<SOL2_MAX_ITEM;++i){
		item=&data->item[i];
		if(item->type==SOL2_ITEM_TYPE_NOTEXIST)continue;
		fprintf(fp,"%d %d %d %d\n",item->type,item->x,item->y,item->hidden);
	}
	fprintf(fp,"-1 -1 -1 -1\n");
	fclose(fp);

}

static int Sol2EditMapDrawAfter(CEasyGame *game){
	char buf[4096];
	TSoldata *data;
	TMe *me;
	data=game->data;
	me=&data->me;
	
	sprintf(buf,"(x,y)=(%3d,%3d)",(me->sp->x>>UNDER_PERIOD)/SOL2_CHIPSIZE,
		(me->sp->y>>UNDER_PERIOD)/SOL2_CHIPSIZE);
	CffontBlitxy(game->font,buf,game->screen,0,0);

}




static int Sol2EditMapControl(CEasyGame *game){
	TSoldata *data;
	TSprite *sp;
	TMe *me;
	TMap *map;
	int kx,ky;
	CInput *inp;
	TItem *item;
	
	static int parts[]={
		
		0,10,11,12,13,14,20,21,22
		
		
		
	};
	
	static int Itemparts[]={
		40,41,42,43,44,45,46,47,48,49,
		50,51,52,53,54,55,56,57,
	};
	
	const int n_parts=sizeof(parts)/sizeof(int);
	const int n_Itemparts=sizeof(Itemparts)/sizeof(int);
	
	static int selected=0;
	static int Itemselected=0;
	static int selectswitch=0;//if 0 ,editting map.
	
	data=game->data;
	me=&data->me;
	map=&data->map;
	sp=me->sp;
	inp=game->input;
	
	if(keyread(game))game->system_end=1;
	
	
	if((sp->x>>UNDER_PERIOD)%24==0)sp->prop.dx=0;
	if((sp->y>>UNDER_PERIOD)%24==0)sp->prop.dy=0;
	CInputUpdate(inp,0);
	if(sp->prop.dx==0){
		if( inp->button[BUTTON_LEFT] && (sp->x>>UNDER_PERIOD)/24>1){sp->prop.dx=-(2<<UNDER_PERIOD);}
		if( inp->button[BUTTON_RIGHT] && (sp->x>>UNDER_PERIOD)/24<SOL2_MAP_X-1 ){sp->prop.dx=2<<UNDER_PERIOD;}
	}
	if(sp->prop.dy==0){
		if( inp->button[BUTTON_UP] && (sp->y>>UNDER_PERIOD)/24>1){sp->prop.dy=-(2<<UNDER_PERIOD);}
		if( inp->button[BUTTON_DOWN] && (sp->y>>UNDER_PERIOD)/24<SOL2_MAP_Y-1 ){sp->prop.dy=2<<UNDER_PERIOD;}
	}
	
	
	if(inp->button[BUTTON_0] && (sp->prop.dx==0 && sp->prop.dy==0)){
		switch(selectswitch){
			case 0:
			map->sp[(sp->x>>UNDER_PERIOD)/24][(sp->y>>UNDER_PERIOD)/24]->number=parts[selected];
			break;
			case 1:
			item=Sol2FindItemSlotByXY(game,(sp->x>>UNDER_PERIOD)/24,(sp->y>>UNDER_PERIOD)/24);
			if(item){
				if(item->type==Itemselected+1){
					if(item->hidden){
						Sol2UnsetItem(game,item);
					}else{
						item->hidden=1;
						TSpriteSetBlinkExtention(item->sp,10);
						
					}
				}else{
					Sol2UnsetItem(game,item);
					Sol2SetItem(game,Itemselected+1,
						(sp->x>>UNDER_PERIOD)/24,(sp->y>>UNDER_PERIOD)/24,0);
				}
			}else{
				Sol2SetItem(game,Itemselected+1,
					(sp->x>>UNDER_PERIOD)/24,(sp->y>>UNDER_PERIOD)/24,0);
					
			}
			break;

		
		}
	}
	if(inp->button[BUTTON_1] && (sp->prop.dx==0 && sp->prop.dy==0)){
		
		//swtic
		switch(selectswitch){
			case 0:selectswitch=1;break;
			case 1:selectswitch=0;break;
		}
		/*
		//spoit
		int x,i;
		x=map->sp[(sp->x>>UNDER_PERIOD)/24][(sp->y>>UNDER_PERIOD)/24]->number;
		selected=0;
		for(i=0;i<n_parts;++i)
			if(x==parts[x]){
				selected=i;break;
			}
		*/
	}
	if(inp->button[BUTTON_2]){
		switch(selectswitch){
			case 0:
			selected--;
			if(selected<0)selected=n_parts-1;
	//		selected%=n_parts;
			break;
			case 1:
			Itemselected--;
			if(Itemselected<0)Itemselected=n_Itemparts-1;
			
			
			break;
		}
	
	}
	if(inp->button[BUTTON_3]){
		switch(selectswitch){
			case 0:
			selected++;
			selected%=n_parts;
			break;
			case 1:
			Itemselected++;
			Itemselected%=n_Itemparts;
			break;
		}
	}
	switch(selectswitch){
		case 0:sp->number=parts[selected];break;
		case 1:sp->number=Itemparts[Itemselected];break;
	}
	Sol2MapMove(game);
	
}

static int SolmapDraw(CEasyGame *game){
	
	SDL_FillRect(game->screen,NULL,SDL_MapRGB(game->screen->format,0,0,0));
	
}

static int SolMapMain(CEasyGame *game){
	
	Sol2LoadMap(game);
	game->draw=SolmapDraw;
	game->control=Sol2EditMapControl;
	game->draw_after=Sol2EditMapDrawAfter;
	CEasyGameStart(game);
	Sol2SaveMap(game);
	
}
//Initializer
static char *enemybgfile="./enemies/list.txt";
static char *enemybgdir="./enemies/";
static char *mapbgfile="list.txt";
static char *mapbgdir="./system/bmp/";
static char *chrbgfile="charabg.txt";
static char *chrbgdir="./character/";
int Sol2Init(CEasyGame *game){
	TSoldata *data;
	TMe *me;
	TMe *fire;
	data=game->data;
	
	data->mapbmps=CBmpsInit(256);
	CBmpsLoadFromFileDir(data->mapbmps,mapbgdir);
	data->charabmps=CBmpsInit(256);
	CBmpsLoadFromFileDir(data->charabmps,chrbgdir);
	data->enemybmps=CBmpsInit(256);
	CBmpsLoadFromFileDir(data->enemybmps,enemybgdir);
	
	
/*
	for(i=0;i<SOL2_MAXFIRE;++i)
		fire->sp[i]=CSpriteSetSetWizNum(game->spriteset,data->charabmps,SOL2_FIRE_SPRITE_INDEX);
*/
}
int Sol2Free(CEasyGame *game){
	TSoldata *data;
	data=game->data;
	
	CBmpsFree(data->mapbmps);
	CBmpsFree(data->charabmps);
	CBmpsFree(data->enemybmps);
	
}

main(int argc,char **argv){
	
	CEasyGame *game;
	static TSoldata data;
	
	if(argc!=2){
		fprintf(stderr,">usage:solmap [filename]\n");
		return;
	}
	
	
	game=CEasyGameInit();
	
//	CEasyGameDefaultSetting320x240x16(game);
	CEasyGameDefaultSetting(game);
	
//	SDLLogo(gameset);
	

	memset(&data,0,sizeof(TSoldata));
	
	game->data=&data;
	
	strcpy(data.mapfilename,argv[1]);
	
	Sol2Init(game);
	
//	CEasyGameStart(game);
	data.spriteset=game->spriteset[GAME_LAYER];
	SolMapMain(game);
	
	Sol2Free(game);
	CEasyGameDetach(game,GAME_LAYER);

	CEasyGameFree(game);




}
Atari(){}
