/*

solomon's key clone

2000/9/28	by adas
*/
#include <math.h>

#include "CBmps.h"
#include "Cffont.h"
#include "CTime.h"
#include "CInput.h"
#include "CWavs.h"
#include "CSprite.h"

/*************
global vars
**************/
SDL_Surface *screen=NULL;

#define	GRAPHICMAX	256
char*	fontfile="engrave16.bmp";
Cffont*	font=NULL;

char*	stagebgfile="stagebg.txt";
char*	stagebgfiledir="./";
CBmps*	stagebg=NULL;


#define	WAVMAX	256
CWavs*	wavs=NULL;

CInput*	gameinput=NULL;

CTime gametime;

#define MAX_SPRITES	1024
CSpriteSet *spriteset=NULL;


//game vars


//common functions
void initialize(void);
void finalize(void);
void load_graphic(void);
void joy_init(void);
void joy_final(void);


//eigen functions

void game_ready(void);

main(int argc,char **argv){
	
	int done=0;
	
//	load_setting();
	initialize();
	load_graphic();
	
	do{
//		CWavsPlayMusicStyle(wavs,0);
//		if(!title())break;
		
//		CWavsPlayMusicStyle(wavs,1);
		
		
		game_ready();
		if(!mainloop())done = 1;
	}while(!done);
	finalize();
}

int keyread(void){
	
	SDL_Event ev;
	static int screennumber=0;
	SDLKey *key;
	char buf[1000];
	
	while(SDL_PollEvent(&ev)){
		switch(ev.type){
			case SDL_QUIT:
			{
				return 1;
			}
			break;
			case SDL_KEYDOWN: {
				key=&(ev.key.keysym.sym);
				
				if(*key==293){//F12
					
					sprintf(buf,"screenshot%04d.bmp",screennumber++);
					if(screennumber>9999)screennumber=0;
					SDL_SaveBMP(screen,buf);
					
				}
				
				if(*key==27){//ESC
					
					return 1;
				}
				
			}break;

		}
	}
	
	
	return 0;
	
}

int my_motion(TSprite *sp){
	
	int vx=0;
	int vy=0;
	CInputUpdate(gameinput,0);
	if ( gameinput->button[BUTTON_UP]){vy=-1;}
	if ( gameinput->button[BUTTON_DOWN]) {vy=1;}
	if ( gameinput->button[BUTTON_RIGHT]) {vx=1;}
	if ( gameinput->button[BUTTON_LEFT]) {vx=-1;}
	sp->x+=vx;
	sp->y+=vy;
	
}

int mainloop(void){
	
	TSprite *me;
	
	
	CTimeReset(&gametime);
	me=CSpriteSetSet(spriteset,stagebg);
//	if(!me)return;
	
	me->x=0;
	me->y=0;
	me->number=10;
	me->prop.dx=1;
	me->motion=my_motion;
	
	do{
		if(keyread())return 0;
		CSpriteSetMove(spriteset);
		if(!gametime.isDelay){
			SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
			CSpriteSetDraw(spriteset,screen);
			SDL_Flip(screen);
		}
		CTimeWait(&gametime);
	}while(1);
	return (1);
}
void game_ready(void){
	;
}

void initialize(void){
	
	srand(time(NULL));
/*	
	if(setting_fullscreen)
		screen=CScreenInitDefaultHW();
	else
		screen=CScreenInitDefault();
*/	
	screen=CScreenInitDefault();
	stagebg=CBmpsInit(GRAPHICMAX);
	font=CffontInitDefault16(fontfile);
	CAudioInitDefault();
	wavs=CWavsInit(WAVMAX);
	joy_init();
	
	spriteset=CSpriteSetInit(MAX_SPRITES);
	
}

void finalize(void){
	
	CBmpsFree(stagebg);
	stagebg=NULL;
	CffontFree(font);
	font=NULL;
	CWavsFree(wavs);
	CAudioClose();
	joy_final();
	CSpriteSetFree(spriteset);
	
}
//and sound
void load_graphic(void){
	
	char filename[1024];
	
	CBmpsLoadFromFileWithDir(stagebg,stagebgfile,stagebgfiledir);
	
	
/*	if(setting_fullscreen){

		CBmpsConvert(cbmps_blocks);
		CBmpsConvert(cbmps_character);
		CBmpsConvert(cbmps_other);
	}
	tscroll.bmp=cbmps_character->bmp[52];
	tscroll.x=0;
	tscroll.y=0;
	tscroll.clock=0;
*/	
	
//	CWavsLoadFromFileWithDir(wavs,wavfile,wavdir);
	
	
}

void joy_init(void){
//	gameinput=CInputInit(setting_joysticknumber,setting_joyenabled);
	gameinput=CInputInit(0,1);
	CInputDefaultSetting(gameinput);
	CInputHoldButtons(gameinput);
	CInputUnholdArrows(gameinput);
//	CInputSetMinAxis(gameinput,setting_joyaxismax);
	CInputSetMinAxis(gameinput,10000);
	return ;
}
void joy_final(void){
	CInputFree(gameinput);
	gameinput=NULL;
	
}

